.\"	$NetBSD: ccdconfig.8,v 1.24 2008/04/30 13:10:52 martin Exp $
.\"
.\" Copyright (c) 1996, 1997 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Jason R. Thorpe.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd October 17, 2003
.Dt CCDCONFIG 8
.Os
.Sh NAME
.Nm ccdconfig
.Nd configuration utility for the concatenated disk driver
.Sh SYNOPSIS
.Nm
.Op Fl cv
.Ar ccd
.Ar ileave
.Op Ar flags
.Ar dev
.Op Ar ...
.Nm
.Fl C
.Op Fl v
.Op Fl f Ar config_file
.Nm
.Fl u
.Op Fl v
.Ar ccd
.Op Ar ...
.Nm
.Fl U
.Op Fl v
.Op Fl f Ar config_file
.Nm
.Fl g
.Op Fl M Ar core
.Op Fl N Ar system
.Oo
.Ar ccd Oo ...
.Oc
.Oc
.Sh DESCRIPTION
.Nm
is used to dynamically configure and unconfigure concatenated disk
devices, or ccds.
For more information about the ccd, see
.Xr ccd 4 .
.Pp
The options are as follows:
.Bl -tag -width indent
.It Fl c
Configure a ccd.
This is the default behavior of
.Nm .
.It Fl C
Configure all ccd devices listed in the ccd configuration file.
.It Fl f Ar config_file
When configuring or unconfiguring all devices, read the file
.Pa config_file
instead of the default
.Pa /etc/ccd.conf .
.It Fl g
Dump the current ccd configuration in a format suitable
for use as the ccd configuration file.
If no arguments are specified, every configured ccd is dumped.
Otherwise, the configuration of each listed ccd is dumped.
.It Fl M Ar core
Extract values associated with the name list from
.Pa core
instead of the default
.Pa /dev/mem .
.It Fl N Ar system
Extract the name list from
.Pa system
instead of the default
.Pa /netbsd .
.It Fl u
Unconfigure a ccd.
.It Fl U
Unconfigure all ccd devices listed the ccd configuration file.
.It Fl v
Causes
.Nm
to be verbose.
.El
.Pp
A ccd is described on the command line and in the ccd configuration
file by the name of the ccd, the interleave factor,
the ccd configuration flags, and a list of one or more devices.
The flags may be represented as a decimal number, a hexadecimal number,
a comma-separated list of strings, or the word
.Dq none .
The flags are as follows:
.Bl -column -offset indent "CCDF_UNIFORM " "0x02 "
.It Em "Symbolic	Numeric	Comment"
.It CCDF_UNIFORM	0x02	Use uniform interleave.
The size of all components is clamped to that of the smallest component.
.It CCDF_NOLABEL	0x04	Ignore raw disklabel.
Useful when creating a new ccd.
.El
.Ss /etc/ccd.conf
The file
.Pa /etc/ccd.conf
is used to configure
.Nm
if
.Fl C
or
.Fl U
is used.
Each line of the configuration file contains arguments as per the
.Fl c
argument:
.Ar ccd
.Ar ileave
.Op Ar flags
.Ar dev
.Op Ar ...
.Pp
A
.Sq #
is a comment, and everything to end of line is ignored.
A
.Sq \e
at the end of a line indicates that the next line should be concatenated
with the current.
A
.Sq \e
preceding any character (other than the end of line) prevents that
character's special meaning from taking effect.
.Pp
See
.Sx EXAMPLES
for an example of
.Pa /etc/ccd.conf .
.Sh FILES
/etc/ccd.conf - default ccd configuration file.
.Sh EXAMPLES
The following command, executed from the command line, would configure ccd0
with 4 components (/dev/sd2e, /dev/sd3e, /dev/sd4e, /dev/sd5e), and an
interleave factor of 32 blocks.
.Bd -unfilled -offset indent
# ccdconfig ccd0 32 0 /dev/sd2e /dev/sd3e /dev/sd4e /dev/sd5e
.Ed
.Pp
An example
.Pa /etc/ccd.conf :
.Bd -unfilled -offset indent
#
# /etc/ccd.conf
# Configuration file for concatenated disk devices
#
.Pp
# ccd           ileave  flags   component devices
ccd0            16      none    /dev/sd2e /dev/sd3e
.Ed
.Sh SEE ALSO
.Xr ccd 4 ,
.Xr ccd.conf 5 ,
.Xr rc 8
.Sh HISTORY
The
.Nm
command first appeared in
.Nx 1.1 .
